var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent, useSlots, computed, ref, openBlock, createElementBlock, normalizeClass, unref, renderSlot, createCommentVNode } from "vue";
import { withTheme } from "../../theme/index.js";
const _hoisted_1 = ["href", "target"];
const _hoisted_2 = {
  key: 0,
  class: "mr-2"
};
const _hoisted_3 = {
  key: 1,
  class: "ml-2"
};
const _hoisted_4 = ["role"];
const _hoisted_5 = {
  key: 0,
  class: "mr-2"
};
const _hoisted_6 = {
  key: 1,
  class: "ml-2"
};
const __default__ = { name: "Button" };
const _sfc_main = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: {
    class: null,
    size: { default: "medium" },
    disabled: { type: Boolean, default: false },
    type: { default: "default" },
    ariaRole: { default: "button" },
    external: { type: Boolean },
    href: null,
    target: null
  },
  emits: ["click"],
  setup(__props, { emit }) {
    const props = __props;
    useSlots();
    const styles = withTheme("button");
    const classes = computed(() => {
      const array = [styles[props.size]];
      array.push(styles.variants[props.type]);
      if (props.disabled)
        array.push(styles.disabled);
      if (props.class)
        array.push(props.class);
      return array;
    });
    const hover = ref(false);
    return (_ctx, _cache) => {
      return props.href ? (openBlock(), createElementBlock("a", {
        key: 0,
        class: normalizeClass(unref(classes)),
        href: props.href,
        target: props.target,
        onMouseover: _cache[0] || (_cache[0] = ($event) => hover.value = true),
        onMouseleave: _cache[1] || (_cache[1] = ($event) => hover.value = false),
        onClick: _cache[2] || (_cache[2] = (e) => emit("click", e))
      }, [
        _ctx.$slots.prefixIcon ? (openBlock(), createElementBlock("div", _hoisted_2, [
          renderSlot(_ctx.$slots, "prefixIcon", { hover: hover.value })
        ])) : createCommentVNode("", true),
        renderSlot(_ctx.$slots, "default", { hover: hover.value }),
        _ctx.$slots.appendIcon ? (openBlock(), createElementBlock("div", _hoisted_3, [
          renderSlot(_ctx.$slots, "appendIcon")
        ])) : createCommentVNode("", true)
      ], 42, _hoisted_1)) : (openBlock(), createElementBlock("button", {
        key: 1,
        class: normalizeClass(unref(classes)),
        role: __props.ariaRole,
        onClick: _cache[3] || (_cache[3] = (e) => emit("click", e))
      }, [
        _ctx.$slots.prefixIcon ? (openBlock(), createElementBlock("div", _hoisted_5, [
          renderSlot(_ctx.$slots, "prefixIcon", { hover: hover.value })
        ])) : createCommentVNode("", true),
        renderSlot(_ctx.$slots, "default", { hover: hover.value }),
        _ctx.$slots.appendIcon ? (openBlock(), createElementBlock("div", _hoisted_6, [
          renderSlot(_ctx.$slots, "appendIcon", { hover: hover.value })
        ])) : createCommentVNode("", true)
      ], 10, _hoisted_4));
    };
  }
}));
export { _sfc_main as default };
//# sourceMappingURL=button.js.map
