var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent, openBlock, createBlock, unref, normalizeClass, withCtx, createElementVNode, createVNode, renderSlot, createTextVNode, toDisplayString, withDirectives, Transition, createElementBlock, Fragment, renderList, createSlots, vShow } from "vue";
import { UButton } from "../button/index.js";
import { UItem } from "../item/index.js";
import { UIcon } from "../icon/index.js";
import { withTheme } from "../../theme/index.js";
import { Menu, MenuButton, MenuItems, MenuItem } from "../../node_modules/@headlessui/vue/dist/components/menu/menu.esm.js";
import render from "../../node_modules/@heroicons/vue/solid/esm/ChevronDownIcon.js";
const __default__ = { name: "Dropdown" };
const _sfc_main = /* @__PURE__ */ defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: {
    text: null,
    items: null
  },
  setup(__props) {
    const styles = withTheme("dropdown");
    const classes = styles;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(unref(Menu), {
        as: "div",
        class: normalizeClass(unref(classes).wrapper)
      }, {
        default: withCtx(({ open }) => [
          createElementVNode("div", null, [
            createVNode(unref(MenuButton), null, {
              default: withCtx(() => [
                renderSlot(_ctx.$slots, "activator", {}, () => [
                  createVNode(unref(UButton), {
                    type: "text",
                    size: "small"
                  }, {
                    appendIcon: withCtx(() => [
                      createVNode(unref(render), {
                        class: "h-5 w-5",
                        "aria-hidden": "true"
                      })
                    ]),
                    default: withCtx(() => [
                      createTextVNode(toDisplayString(__props.text) + " ", 1)
                    ]),
                    _: 1
                  })
                ])
              ]),
              _: 3
            })
          ]),
          withDirectives(createElementVNode("div", null, [
            createVNode(Transition, {
              "enter-active-class": unref(classes).transition.enterActiveClass,
              "enter-from-class": unref(classes).transition.enterFromClass,
              "enter-to-class": unref(classes).transition.enterToClass,
              "leave-active-class": unref(classes).transition.leaveActiveClass,
              "leave-from-class": unref(classes).transition.leaveFromClass,
              "leave-to-class": unref(classes).transition.leaveToClass
            }, {
              default: withCtx(() => [
                renderSlot(_ctx.$slots, "menu", {}, () => [
                  createVNode(unref(MenuItems), {
                    class: normalizeClass(unref(classes).menu)
                  }, {
                    default: withCtx(() => [
                      (openBlock(true), createElementBlock(Fragment, null, renderList(__props.items, (item) => {
                        return openBlock(), createElementBlock("div", {
                          key: item.name
                        }, [
                          createVNode(unref(MenuItem), {
                            as: "div",
                            disabled: item.disabled
                          }, {
                            default: withCtx(({ active }) => [
                              renderSlot(_ctx.$slots, "default", {
                                active,
                                item
                              }, () => [
                                createVNode(unref(UItem), {
                                  href: item.href,
                                  disabled: item.disabled,
                                  active
                                }, createSlots({
                                  default: withCtx(() => [
                                    createTextVNode(" " + toDisplayString(item.name), 1)
                                  ]),
                                  _: 2
                                }, [
                                  item.iconSrc ? {
                                    name: "prefixIcon",
                                    fn: withCtx(() => [
                                      createVNode(unref(UIcon), {
                                        src: item.iconSrc
                                      }, null, 8, ["src"])
                                    ])
                                  } : item.icon ? {
                                    name: "prefixIcon",
                                    fn: withCtx(() => [
                                      createVNode(unref(UIcon), null, {
                                        default: withCtx(() => [
                                          createTextVNode(toDisplayString(item.icon), 1)
                                        ]),
                                        _: 2
                                      }, 1024)
                                    ])
                                  } : void 0
                                ]), 1032, ["href", "disabled", "active"])
                              ])
                            ]),
                            _: 2
                          }, 1032, ["disabled"])
                        ]);
                      }), 128))
                    ]),
                    _: 3
                  }, 8, ["class"])
                ])
              ]),
              _: 3
            }, 8, ["enter-active-class", "enter-from-class", "enter-to-class", "leave-active-class", "leave-from-class", "leave-to-class"])
          ], 512), [
            [vShow, open]
          ])
        ]),
        _: 3
      }, 8, ["class"]);
    };
  }
}));
export { _sfc_main as default };
//# sourceMappingURL=dropdown.js.map
